format compact; clear all; fclose all; clc; 
% cluster = parcluster('local');
% cluster.NumWorkers = 4;  %only running 3 lifts at a time 7:9
tic;


bModelDirectory = 'C:\Users\jbanks3\Desktop\DoD_Harvard\BaseModels\';
SubSubjDirectory =   'C:\Users\jbanks3\Desktop\DoD_Harvard\Data\';

[Onum, Otxt] = xlsread([SubSubjDirectory 'AWall_WorkSheet.xlsx'], 'Organize');

    StrSubjs  = Otxt(:,1);  
    Trialnums = Onum(:,1);  
%% pre stuff
import org.opensim.modeling.*
ModelVisualizer.addDirToGeometrySearchPaths('C:\OpenSim 4.2\Geometry');  %maybe works to prevent log error?  unsure if only need to do once?
    
for m = 1  : size(Trialnums, 1) 
    
    if m>size(StrSubjs,1)
        StrSubj = StrSubjs{end};  
    else
        StrSubj = StrSubjs{m};  
    end
    TRCfile_base = [StrSubj '_00' num2str(Trialnums(m)) ];
        
    Orow = find(strcmp(StrSubj, Otxt)==1 & Onum==Trialnums(m));
    EM = Otxt{Orow,3};
    TBoxM = Onum(Orow, 4); 
    
    
    if strcmp(EM, 'Exo')
        ExoQ = 1;
    else       %no exo, so skip
        ExoQ = 0; 
       % disp(['* Skipping all ' TRCfile_base ' lifts *']); continue
    end 
       
 
SubjDirectory   = [SubSubjDirectory StrSubj '\'];    
actuatorpath   = [bModelDirectory 'Actuators_' EM '.xml'];
modelfile       = [SubjDirectory StrSubj '_51DoF_' EM '_noBox.osim'];

load([SubjDirectory 'Lifts.mat']);

    for l= 7:9        
        TRCfile = [TRCfile_base '_Lift' num2str(l)];
        
    IKfile =   [SubjDirectory TRCfile '_IK.mot' ];  disp(IKfile);

    [IKpath, IKname, ~] = fileparts(IKfile);
        GRFfilename     = [SubjDirectory TRCfile '_forces.mot'];
    
IKData = read_motionFile(IKfile); %Storage(IKfile);
        IKtime = IKData.data(:,1);
        iTime = round(IKtime(1,1), 5); %round(IKData.getFirstTime(), 5);
        fTime =  round(IKtime(end,1), 5); %round(IKData.getLastTime() , 5);
        StepRate = round(mean(diff(IKtime)), 5); %round(IKData.getMinTimeStep(), 5);
            Steps = length(IKtime); %round( ( (fTime-iTime) / StepRate ) + 1 );
 if ExoQ == 1
% Exo 
    Proc_name       = [SubjDirectory num2str(Trialnums(m)) '_processed_Lift' num2str(l) '.mat'];
 ExoData = load(Proc_name);
 ExoData = ExoData.Proc.data(:,[1,3]);  %time and load cell
 else
     ExoData = zeros(IKData.nr, 2);
 end

%%%% get lift times
    TRCfile_base = replace(IKname, ['_Lift' num2str(l) '_IK'], '');

    
%% each frame stuff
%% Read in osim model 
    import org.opensim.modeling.*
    osimModel = Model(modelfile);
    path='C:\OpenSim 4.2\Geometry';
        ModelVisualizer.addDirToGeometrySearchPaths(path);     
        state = osimModel.initSystem;
        Rbodies = osimModel.get_BodySet(); % Rbodies.getSize()
        Joints = osimModel.get_JointSet();
        markerSet = osimModel.updMarkerSet();
    
    % Get info   
    Nstates    = osimModel.getNumStateVariables();
    Ncontrols  = osimModel.getNumControls();

    osimModel.equilibrateMuscles(state);  
    osimModel.realizePosition(state);  %some where where it said to do this?
    
        states_h = cell(((IKData.nc-1)*2),1);  %352 kinematic coordinates before muscles stuff (if want muscles too use Nstates); 'nc' has time, so take out and 2x because value and speed
    for i = 1:length(states_h)
        states_h(i) = cell(osimModel.getStateVariableNames().getitem(i-1));
    end
  
     for i = 1:(IKData.nc-1) %352 kinematic coordinates before muscles stuff (if want muscles too use Nstates); 'nc' has time, so take out and 2x because value and speed
        j=(i-1)*2+1;  
        CoordState = states_h{j};
            backslash = strfind(CoordState, '/');
        CoordState = CoordState(backslash(end-1)+1 : backslash(end)-1);
        Coord(j) = osimModel.updCoordinateSet().get(CoordState);
    end 
        
    UseCoords = [   Coord(19) Coord(25) Coord(31) Coord(37) Coord(43)...
                    Coord(49) Coord(55) Coord(61) Coord(67) Coord(73) Coord(79) Coord(85) Coord(91) Coord(97) Coord(103) Coord(109) Coord(115) Coord(121)... 
                    Coord(311) Coord(321) ];  %use 'states_h' to decide
      
MAarray = nan(IKData.nr, 43); % 42 = time + 2x 20 MA + ExoForce + (L5S1 to Box distance)
    MAarray(:,1) = IKData.data(:,1);
    MAarray(:,42) = ExoData(:,2);
for f=1:IKData.nr
        disp(['on frame: ' num2str(f) ' of ' num2str(IKData.nr)]);
    StatesIK = IKData.data(f, :);
        StatesIK = StatesIK * 1;  %just in case want to look at baseline, can make this "0"

    for k = 2:length(StatesIK) %1=time, so skip
                IKLabel = [IKData.labels{k} '/value'];
                StateLabel =  cell(osimModel.getStateVariableNames().getitem(k*2-4));  %this math works, otherwise can uncomment thnings and cycle, but takes a lot longer
                
                if sum(k==[5 6 7 173 174 175])  %states that are linear and not angular (so don't need put in radians);  Shouldn't need to remove 173:175 for nonExos because just won't have those numbers!
%                     disp(IKLabel);
%                     disp(StateLabel);
                    sMulti =1;
                else
                    sMulti = pi/180;  %put in radians!!!! IK has angular in degress... but be careful, as this puts Pelvis linear (and any other) in radians too!
                end
                osimModel.setStateVariableValue(state, char(StateLabel), StatesIK(k)*sMulti);  %put in radians!!!! IK has angular in degress... but be careful, as this puts Pelvis linear (and any other) in radians too!

    end
    osimModel.equilibrateMuscles(state);  
    osimModel.realizePosition(state);  %some where where it said to do this?
    
      if ExoQ == 1    
        Exol = osimModel.updForceSet().get("Exo_Actuator_l");  
            Exol = PathActuator.safeDownCast(Exol);   
        Exor = osimModel.updForceSet().get("Exo_Actuator_r");  
            Exor = PathActuator.safeDownCast(Exor); 
        
        ExolA = nan(1,length(UseCoords));
            ExorA = ExolA;
        for c=1:length(ExolA)
            ExolA(c) = Exol.computeMomentArm(state, UseCoords(c));              
            ExorA(c) = Exor.computeMomentArm(state, UseCoords(c)); 
        end
      else
          ExolA = zeros(1, 20);
          ExorA = ExolA;
      end
      
       MAarray(f,2:21) = ExolA;
       MAarray(f,22:41) = ExorA;
       
%%
%%% Box location
    Box = Rbodies.get('Box_r') ;     
    Box_gPos = Box.getPositionInGround(state);
        Boxr_gPos = osimVec3ToArray(Box_gPos);
    Box = Rbodies.get('Box_l') ;     
    Box_gPos = Box.getPositionInGround(state);
        Boxl_gPos = osimVec3ToArray(Box_gPos);          
        Box_tCoM = mean([Boxr_gPos; Boxl_gPos]) ;       
%         localPos = Box.get_mass_center();     %get same answer as above!   
%         globalPos = Box.findStationLocationInGround(state, localPos);
%globalPos = Box.findStationLocationInAnotherFrame(state, localPos, sacr);

%%% L5S1 joint
L5S1jt = Joints.get('L5_S1_IVDjnt');
Frame0Pos = L5S1jt.get_frames(0).get_translation;
sacr = Rbodies.get('sacrum') ; %sacr.getPositionInGround(state)... this doesn't get same answer as below
L5S1_gPos = sacr.findStationLocationInGround(state, Frame0Pos);
    L5S1_gPos = osimVec3ToArray(L5S1_gPos);

                %%%% can get same answer for L5S1 joint with marker!
                %     observedMarker = markerSet.get('L5S1');
                %         markerParentBody = observedMarker.getParentFrameName();
                %                 markerParentBody = erase(char(markerParentBody), '/bodyset/');
                %         mBody = osimModel.getBodySet().get(markerParentBody);            
                %             %SE = model.getSimbodyEngine();
                %             %gbody = model.getGround();
                %             %localPos = osimVec3FromArray([0.0, 0.0, 0.0]); %preallocate, apparently not needed 
                %             %globalPos = localPos ;  %
                %         localPos = observedMarker.get_location();        
                %         globalPos = mBody.findStationLocationInGround(state, localPos);

%Box2L5S1 =    sqrt( sum((L5S1_gPos - Box_tCoM).^2) ) ;     
Box2L5S1 = Box_tCoM(1) - L5S1_gPos(1);
    MAarray(f,43) = Box2L5S1;    
    
end

%% write stuff
wArray.data = MAarray;
wArray.nr = size(MAarray,1);
wArray.nc = size(MAarray,2);
wArray.labels = {   'time',...
                    'L5S1_FE_Exol_MA', 'L4L5_FE_Exol_MA', 'L3L4_FE_Exol_MA', 'L2L3_FE_Exol_MA', 'L1L2_FE_Exol_MA',...
                    'T12L1_FE_Exol_MA', 'T11T12_FE_Exol_MA', 'T10T11_FE_Exol_MA', 'T9T10_FE_Exol_MA', 'T8T9_FE_Exol_MA', 'T7T8_FE_Exol_MA', 'T6T7_FE_Exol_MA', 'T5T6_FE_Exol_MA', 'T4T5_FE_Exol_MA', 'T3T4_FE_Exol_MA', 'T2T3_FE_Exol_MA', 'T1T2_FE_Exol_MA', 'NT1_FE_Exol_MA',...
                    'rHip_FE_Exol_MA', 'lHip_FE_Exol_MA',...
                    'L5S1_FE_Exor_MA', 'L4L5_FE_Exor_MA', 'L3L4_FE_Exor_MA', 'L2L3_FE_Exor_MA', 'L1L2_FE_Exor_MA',...
                    'T12L1_FE_Exor_MA', 'T11T12_FE_Exor_MA', 'T10T11_FE_Exor_MA', 'T9T10_FE_Exor_MA', 'T8T9_FE_Exor_MA', 'T7T8_FE_Exor_MA', 'T6T7_FE_Exor_MA', 'T5T6_FE_Exor_MA', 'T4T5_FE_Exor_MA', 'T3T4_FE_Exor_MA', 'T2T3_FE_Exor_MA', 'T1T2_FE_Exor_MA', 'NT1_FE_Exor_MA',...
                    'rHip_FE_Exor_MA', 'lHip_FE_Exor_MA',...
                    'ExoForce',...
                    'L5S1toBox'};

                    wAname = replace(IKfile, '_IK.mot', '_MAs.sto');
write_motionFile(wArray, wAname)
    
    end %for l 7:9  
%delete(gcp('nocreate')); 
    
end % for TRCnums

toc



       